// $Date: 2002/03/05 14:41:19 $ $Author: stefanw $ $Revision: 1.4 $

// 
// patt, repl, OPT (wie fur match)
// 
// 
// 
// 
// 

Rule::_mult:=
  [
   Rule(A*(B+C), A*B+A*C),
   // de-normalisiere
   Rule((A+B)*C^(-1), A/C + B/C),
   Rule(A*(B+C)^(-1), A/B - C*A/(B*(B+C)), Cond={B -> B<>0}), 

   
   Rule(X*A^B*A^C, X*A^(B+C)),
   Rule(A^C*B^C, (A*B)^C, Cond={(A, B, C) -> is(A>=0 or B>=0 or C in R_)} ),
   // allgemeingueltig??


   Rule(A/(B^(1/2) + C), hold(A*(B^(1/2) - C)/(B - C^2))),

   // exp-Rules

   Rule(exp(A)*exp(B), exp(A+B)),


   // Rules for trig. functions

   Rule(sin(X)/cos(X), hold(tan(X))),
   
   // Rules for gamma

   Rule(C*gamma(A)/gamma(B), hold(C*product(B+k, k=0..A-B-1)), Cond={(A, B) -> A > B and
                                                         type(A-B)=DOM_INT}),

   
   Rule(C*gamma(A)/gamma(B), hold(C/product(A+k, k=0..B-A-1)), Cond={(A, B) -> A < B and
                                                         type(A-B)=DOM_INT})

   
   ]:
