// $Date: 2002/11/06 08:18:50 $ $Author: cube $ $Revision: 1.2.2.1 $

// 
// patt, repl, OPT (wie fur match)
// 
// 
// 
// 
// 

Rule::_power:=
  [Rule(X^n, hold(map(X, _power, n)),
        Cond = {(X, n) -> is(n, Type::Integer) = TRUE and type(X) = "_mult"}),
   
   Rule(sqrt(X), hold(sign(op(X, 1))*op(X, 1)),
        Cond = {X -> type(X) = "_power"
                and is(op(X, 1), Type::Real) = TRUE
                and op(X, 2) = 2}),

   Rule(X^n, hold(expand(X^n)),
        Cond = {(X, n) -> type(n)=DOM_INT and n>0 and type(X)="_plus"}),


   Rule(X^p, hold((proc(n, p)
                    local l;
                   begin
                    l:=stdlib::ifactor(n);
                    l[1]^p * _mult(l[2*i]^(l[2*i+1]*p) $i=1..nops(l) div 2)
                  end_proc)
                    (X,p)),
        Cond= {(X, p) -> type(X)=DOM_INT and type(p) = DOM_RAT}),
   
   // voruebergehend:

   
   Rule(X^p, hold(radsimp(X^p)), Cond= {p -> type(p) = DOM_RAT}),

   
   Rule(X^p, hold(exp(op(X)*p)), Cond = {X -> type(X) = "exp"}),
   Rule(X^r, hold(op(X, 1)^(op(X, 2)*r)),
        Cond = {r -> is(r, Type::Rational) = TRUE,
                X -> type(X) = "_power" and
                is(op(X, 1), Type::NonNegative) = TRUE and
                is(op(X, 2), Type::Rational) = TRUE}),
   Rule(sqrt(X), hold(sign(op(X, 1))*op(X, 1)),
        Cond = {X -> type(X) = "_power"
                and is(op(X, 1), Type::Real) = TRUE
                and op(X, 2) = 2}),
   Rule(X^Y, hold(exp(Y*ln(X))),
        Cond = {Y -> not testtype(Y, Type::Constant),
                // If X is non-zero or if it's not 
                // determinable if X is non-zero (in 
                // such a case is yields UNKNOWN)
                // the rule is applied.
	        X -> is(X=0) <> TRUE}),

   Rule((X*Y)^Z, X^Z * Y^Z),

   Rule(X^(A+B), hold(X^A * X^B)),
   
   Rule(X^p, hold(isqrt(X)^(2*p)),
        Cond = {X -> (domtype(X) = DOM_INT and isqrt(X)^2 = X)}),
   Rule(sin(X)^2, 1 - cos(X)^2),
   Rule(cos(X)^2, 1 - sin(X)^2)
   ]:
