

Rule::_unequal:=
[

 // decide truth immediately for constant expressions
 Rule(A<>B, hold(is(A<>B)),
      Cond={(A, B)-> testtype(A, Type::Constant)=TRUE and
            testtype(B, Type::Constant)=TRUE}),
 
 Rule(A<>B, hold(B<>A)),
 Rule(A<>B, hold(A>B or A<B), Cond = {(A, B)-> is(A, Type::Real)=TRUE and
                                      is(B, Type::Real)=TRUE} ),

 Rule(A*B <>0, hold(A<>0 and B<>0)),
 Rule(A^(-1) <> 0, TRUE)
 ]: