// $Date: 2002/02/04 08:50:26 $ $Author: walter $ $Revision: 1.5 $ 
/*--
intlib::algred(f,n) - reduces f modulo the polynomials in _global_k_alg and returns 
numerator and denominator.
--*/
intlib::algred:=proc(f,n)
  local i;
// global _global_k_sub,_global_k_alg; 
begin
  if n<2 or (map({op(_global_k_alg)},domtype)minus{DOM_INT}={})
    then return(normal(f));
  end_if;
  for i from n downto 2 do
    if domtype(_global_k_alg[i])=DOM_POLY then
      f:= expr(intlib::sim(divide(poly(numer(f),[_global_k_sub[i]])*
	         intlib::pdioe(divide(poly(denom(f),[_global_k_sub[i]]),_global_k_alg[i],Rem),
                 _global_k_alg[i],poly(1,[_global_k_sub[i]]))[1],_global_k_alg[i],Rem)));
      else next;
    end_if;
  end_for;
  return(normal(f));
end_proc:
