// $Date: 2001/08/13 07:40:06 $ $Author: tom $ $Revision: 1.11 $ 

/*++
	adt - Library for abstract data types 

++*/

adt:=newDomain("adt"):
adt::create_dom:=hold(adt):
adt::info:="Library 'adt':  a collection of abstract data types":
adt::interface:={hold(Stack), hold(Queue), hold(Tree)}:

alias(path = pathname("ADT")):

adt::Heap:= loadproc(adt::Heap, path, "heap"):
adt::Stack:= loadproc(adt::Stack, path, "stack"):
adt::Stream:= loadproc(adt::Stream, path, "stream"):
adt::Queue:= loadproc(adt::Queue, path, "queue"):
adt::Tree := loadproc(adt::Tree , path, "tree"):

adt::type:= ADT -> ADT::type:

stdlib::LoadlibState["adt"]:= TRUE:

null():

// end of file 
