// $Date: 2001/11/26 08:29:05 $ $Author: tonner $ $Revision: 1.40 $

// kg, 13/12/94

//
// prog.mu -- define/load auxiliary functions
//

prog:= newDomain("prog"):
prog::create_dom:=hold(prog):

prog::info:= "Library 'prog': programming utilities":
prog::interface:=
   {
    //hold(allDomainMethods),
    //hold(findSlot),
    //hold(remember),
    hold(allFunctions),
    hold(calltree),
    hold(changes),
    hold(check),
    hold(checkDisableMessage),
    hold(error),
    hold(exprtree),
    hold(find),
    hold(getname),
    hold(getOptions),
    hold(init),
    // nur noch interner Gebrauch
    //hold(makeBinLib),
    hold(memuse),
    hold(ntime),
    hold(profile),
    hold(tcov),
    hold(test),
    hold(testfunc),
    hold(testinit),
    hold(testnum),
    hold(testexit),
    hold(trace),
    hold(traced),
    hold(untrace)
    }:

alias(path = pathname("PROG")):

// internal for prog::check
prog::globalIdents:= table():
prog::PATH:= []: // 
prog::NMSG:= {}: // disabled messages
prog::Entries:= loadproc(prog::Entries , path, "checkini"):
prog::VNM:= loadproc(prog::VNM , path, "check"):
prog::isGlobal:= loadproc(prog::isGlobal, path, "checkini"):

prog::allDomainMethods:= loadproc(prog::allDomainMethods, path, "allfunc"):
prog::allFunctions:= loadproc(prog::allFunctions, path, "allfunc"):
prog::calltree:= loadproc(prog::calltree, path, "calltree"):

// compatibility
prog::Changes:= loadproc(prog::Changes, path, "compatible"):
prog::changes:= loadproc(prog::changes, path, "compatible"):

prog::check:= loadproc(prog::check, path, "check"):
prog::checkDisableMessage:= loadproc(prog::checkDisableMessage, path, "checkset"):
prog::setcheckglobals:= loadproc(prog::setcheckglobals, path, "checkset"):
prog::checkexample:= loadproc(prog::checkexample, path, "checkexa"):

prog::error:= loadproc(prog::error, path, "error"):

prog::exprtree:= loadproc(prog::exprtree, path, "exprtree"):

prog::find:= loadproc(prog::find, path, "find"):
prog::findSlot:= loadproc(prog::findSlot, path, "findSlot"):

// extract options from argument list
prog::getOptions:= loadproc(prog::getOptions, path, "getoptions"):

prog::getname:= loadproc(prog::getname , path, "checknm"):

prog::init := loadproc(prog::init , path, "checkini"):

prog::makeBinLib:= loadproc(prog::makeBinLib, path, "makelib"):

prog::memuse:= loadproc(prog::memuse, path, "memuse"):

// system independend time unit
prog::ntime:= loadproc(prog::ntime, path, "ntime"):

// 
prog::profile:= loadproc(prog::profile, path, "profile"):

// complex remember mechanism
prog::remember:= loadproc(prog::remember, path, "remember"):

//
prog::tcov:= loadproc(prog::tcov, path, "tcov"):

// test environment
prog::test:= loadproc(prog::test, path, "test"):
prog::testexit:= loadproc(prog::testexit, path, "test"):
prog::testfunc:= loadproc(prog::testfunc, path, "test"):
prog::testinit:= loadproc(prog::testinit, path, "test"):
prog::testnum:= loadproc(prog::testnum, path, "test"):

// trace functions
prog::trace:= loadproc(prog::trace, path, "trace"):
prog::traced:= loadproc(prog::traced, path, "trace"):
prog::untrace:= loadproc(prog::untrace, path, "trace"):

// manipulate functions to write test files
prog::maketest:= loadproc(prog::maketest, path, "maketest"):

null():
