// $Date: 2001/08/22 14:50:47 $ $Author: stefanw $  $Revisions: $


/********************************

 misc::subExpressions(x, tt <, NoOperators> )

 x  - any object
 tt - type or set of types
 NoOperators - option

 returns the set of all subexpressions of x that
 are of type tt, or of one of the types in the set tt

 With the option NoOperators given, no subexpressions of operators
 are returned


********************************/


// war frueher in hastype definiert  
misc::subExpressions :=
proc(x,tt) : DOM_SET
  local s,t, NoOp;
begin
 
  if contains([args()], hold(NoOperators))>0 then
    NoOp:= hold(NoOperators)
  else
    NoOp:= null()
  end_if;
  
  s:={};
  if type(tt) <> DOM_SET then
    t:={tt}
  else
    t := tt
  end_if;

  misc::maprec(x, t = (y -> (s := s union {y}; y)), NoOp );
  s
end_proc:
