// $Date: 2001/08/13 07:41:31 $ $Author: tom $ $Revision: 1.13 $ 
// tonner, 23/06/98 

/*++
output::MathContent -- Wrapper for Content markup
++*/

MathContent := newDomain(hold(MathContent)):
MathContent::create_dom:=hold(MathContent):
MathContent::print := x -> extop(x,1):
MathContent::new := 
proc() 
  local cl, doc, aliasList;
begin 
  cl:= clientObject();
  if traperror((
       doc:= cl::document();
       doc::release()
     )) <> 0 
  then // not a calc control
    if length(args()) > 300 then
      error("too big")
    end_if;
  end:
  if args() = null() then
    new(dom, hold(``))
  else
    // return MathContent objects
    if domtype(args()) = MathContent then
      return(args())
    elif domtype(args()) = Content then
      return(new(dom, args()))
    end_if;
    
    aliasList := _pref(hold(Alias));
    if testtype(aliasList, DOM_LIST) and op(aliasList, 1) = TRUE and
      testtype(op(aliasList, 2), DOM_PROC) then
      Content::setAliasTab(op(aliasList, 2)())
    else
      Content::setAliasTab(table)
    end_if;
    new(dom, Content::new(args())) 
  end_if;
end:

MathContent::map := (x, y) -> new(dom, map(extop(x), y)):
MathContent::expr := x -> Content::expr(extop(x,1)):
MathContent::op := proc(x, l = null()) begin Content::op(extop(x,1), l) end_proc:
MathContent::subsop := proc(x, l = null()) begin MathContent(Content::subsop(extop(x,1), l, Unsimplified)) end_proc:
MathContent::testtype := FALSE:
MathContent::create_dom := hold(MathContent):

