/*  

($Date: 2002/02/14 16:32:50 $  $Author: so $   $Revision: 1.1 $)
HKEY_CURRENT_USER\Software\ES-Computing\EditPlus 2\Install\Install 2.1=nix
*/
        
plot::histogram:= proc(l)
    local big, bigY, bigZ, lineWidth, myLine, myPoint, notch, notchDown, 
    notchIndent, notchUp, outRange, plotAgainst, range, rangeX, rangeY,
    boxList, check, color, dim, nli, options, pw, st, t, v, zaehl,i,
    rangez, small, smallY, smallZ, startX, startY, temp, x, y, z, shift,
    stretch,notchIndentU,centers, widths, outRangeY, outRangeZ, 
    x25, x50, x75, y25, y50, y75, z25, z50, z75;

begin

//-------------------------------------------------------------------------
//      myLine and myPoint are used to draw x/y swapped lines/points
//-------------------------------------------------------------------------

myLine:=proc(tausche, start, ende) //unnormal, start, ende ,opt
  local opt;  
  begin
	opt := args(4..args(0));
   	if (tausche=Horizontal) and nops(opt)>0 
		then return (plot::line([start[2],start[1]],[ende[2],ende[1]], op(opt)) )
		else return (plot::line( [start[1],start[2]],[ende[1],ende[2]],op(opt)) )
    	end_if;	  				
   end_proc;

myPoint:=proc(tausche, start, ende)
   local opt;
   begin   	
   	   opt := args(4..args(0));
	   if (tausche=Horizontal) and nops(opt)>0 then return (plot::Point( ende,start, op(opt) )) end_if;
	   if (tausche=Horizontal) then return (plot::Point( ende,start )) end_if;
	   if nops(opt)>0 then return (plot::Point( start,ende, op(opt) )) end_if;
	   return (plot::Point( start,ende))								
   end_proc;


sortIn:=proc(element,a,b,l2,ranges) // Element gibt einzusortierendes Element an, a und b Grenzen
begin
    if (a>b) then
    	return (ranges);
    end_if;
    found:=FALSE;
    if (useBounds=Left) then
   	    if (element>=op(l2,[ceil((a+b)/2),1])) and (element<op(l2,[ceil((a+b)/2),2])) then
        	ranges[ceil((a+b)/2)]:=ranges[ceil((a+b)/2)]+1;
            found:=TRUE;
        end_if;
     end_if;
    if (useBounds=Right) then
   	    if (element>op(l2,[ceil((a+b)/2),1])) and (element<=op(l2,[ceil((a+b)/2),2])) then
        	ranges[ceil((a+b)/2)]:=ranges[ceil((a+b)/2)]+1;
            found:=TRUE;
         end_if;
    end_if;
    if (useBounds=Both) then
   	    if (element>=op(l2,[ceil((a+b)/2),1])) and (element<=op(l2,[ceil((a+b)/2),2])) then
        	ranges[ceil((a+b)/2)]:=ranges[ceil((a+b)/2)]+1;
            found:=TRUE;
        end_if;
    end_if;

    if (b-a>=1) and not found then
           if (element>op(l2,[ceil((a+b)/2),2])) then // rechts weitermachen
           	 ranges:=sortIn(element,ceil((a+b)/2)+1,b,l2,ranges);
            end_if;
           if (element<=op(l2,[ceil((a+b)/2),1]))  then
      	        ranges:=sortIn(element,a,ceil((a+b)/2)-1,l2,ranges);
          end_if;
    end_if;
    return(ranges);
end_proc;

Box3d:=proc(a,b,c,x,y,z) //unnormal, start, ende ,opt
  local opt;  
  begin
  if (y=0) then
  	return(plot::Surface3d( [e1, 0, g1], e1=a..x, g1=c..z ))
  end_if;
	return(
/*    plot::Group(  
          plot::Surface3d( [e1, f1, z], e1=a..x, f1=b..y  ),
          plot::Surface3d( [e1, y, g1], e1=a..x, g1=c..z  ),
          plot::Surface3d( [x, f1, g1], f1=b..y, g1=c..z  ),
          plot::Surface3d( [e1, f1, c], e1=a..x, f1=b..y  ),
          plot::Surface3d( [e1, b, g1], e1=a..x, g1=c..z  ),
          plot::Surface3d( [a, f1, g1], f1=b..y, g1=c..z  )
                 )        
            );
*/
plot::Group(  
          plot::Polygon( plot::Point(a,b,c),
                         plot::Point(x,b,c),
                         plot::Point(x,y,c),
                         Filled=TRUE
                        ),
          plot::Polygon( plot::Point(a,b,c),
                         plot::Point(a,y,c),
                         plot::Point(x,y,c),
                         Filled=TRUE
                        ),
          plot::Polygon( plot::Point(x,b,c),
                         plot::Point(x,b,z),
                         plot::Point(x,y,c),
                         Filled=TRUE
                        ),
          plot::Polygon( plot::Point(x,y,z),
                         plot::Point(x,y,c),
                         plot::Point(x,b,z),
                         Filled=TRUE
                        ),

          plot::Polygon( plot::Point(a,b,c),
                         plot::Point(x,b,c),
                         plot::Point(x,b,z),
                         Filled=TRUE
                        ),

          plot::Polygon( plot::Point(a,b,c),
                         plot::Point(a,b,z),
                         plot::Point(x,b,z),
                         Filled=TRUE
                        ),
          plot::Polygon( plot::Point(a,b,c),
                         plot::Point(a,b,z),
                         plot::Point(a,y,c),
                         Filled=TRUE
                        ),

          plot::Polygon( plot::Point(a,y,c),
                         plot::Point(a,b,z),
                         plot::Point(a,y,z),
                         Filled=TRUE
                        ),

          plot::Polygon( plot::Point(a,y,z),
                         plot::Point(x,y,z),
                         plot::Point(x,y,c),
                         Filled=TRUE
                        ),

          plot::Polygon( plot::Point(a,y,c),
                         plot::Point(a,y,z),
                         plot::Point(x,y,c),
                         Filled=TRUE
                        ),

          plot::Polygon( plot::Point(a,y,z),
                         plot::Point(a,b,z),
                         plot::Point(x,b,z),
                         Filled=TRUE
                        ),

          plot::Polygon( plot::Point(a,y,z),
                         plot::Point(x,b,z),
                         plot::Point(x,y,z),
                         Filled=TRUE
                        )


)

)          

   end_proc;


// -------------------------=====CHECK FORMAT====-------------------------------------------------
// --------------------checks, if the arguments are used in the right way-------------------------
// --------------------and extracts them to local variables---------------------------------------
// -----------------------------------------------------------------------------------------------

check:= proc() local p;
  begin
       // Copy one Option to P
      for i from 1 to nops(options) do
          if type( (p := options[i]) ) <> "_equal" then 
               if (testtype(p, Type::ListOf(DOM_LIST))) 
                 then 
                      l2:=p;
                      l2 := float(l2);
                     
                  if (_union(map({op(l2[i])},domtype )$i=1..nops(l2)) minus {DOM_FLOAT,stdlib::Infinity}) <> {} then 
                       error("Some data elements are not numerical"); 
                  end_if;
                      for j from 1 to nops(l2) do 
                        if( nops(op(l2,j))  <> 2 ) 
                           then error("2 values required in list ".j." of second list") ; 
                        end_if;
                      end_for;
                 else error("specification of the form 'option = value' expected");
		       end_if;
          else	
	  	// Now test the Arguments and set them to local variables
          case op(p,1)
	  
      of hold(Colors) do
              color:= op(p,2);
	      if domtype(color) <> (DOM_LIST)  then
                  error("option 'Colors': list with RGB color values expected")
              end_if;
	      
	      if domtype(op(color,1) ) <> (DOM_LIST) then //keine ListOfLists, sondern nur eine einfache Liste
	          if (nops(color) mod 3 <> 0) or (( op(color, j) >1 )or op(color,j)<0)  $ j=1..nops(color)  then
		    error("Wrong Color Type"); //Test ob korrekte Anzahl Argumente + Werte zwischen 0 und 1
		   end_if;             
		  color:=[color];	      
	       end_if;
	      options[i]:= FAIL; // Cancel the Argument
              break

      of hold(Intervals) do
	      interv:= op(p,2);
	      if (domtype(interv) <> (DOM_INT)) or (interv<0) then
	          error("option 'Intervals': positive Integer expected")
	      end_if;
              options[i]:= FAIL;
              break


      of hold(LineWidth) do
	      lineWidth:= op(p,2);
	      if (domtype(lineWidth) <> (DOM_INT)) or (lineWidth<0) then
	          error("option 'LineWidth': positive Integer expected")
	      end_if;
              options[i]:= FAIL;
              break

      of hold(Width) do
	      width:= op(p,2);
	      if (domtype(width) <> (DOM_INT)) or (width<=0) then
	          error("option 'Width': positive Integer expected")
	      end_if;
              options[i]:= FAIL;
              break

    of hold(UseBounds) do
	      useBounds:=op(p,2);
	      if(useBounds <> Left and useBounds <> Right and useBounds <> Both) then
		    error("option 'UseBound': Left or Right or Both expected")
	      end_if;	
	      options[i]:=FAIL;
	      break

    of hold(Draw3D) do
	      draw3D:=op(p,2);
	      if(draw3D <> TRUE and draw3D<>FALSE) then
		    error("option 'Draw3D': TRUE or FALSE expected")
	      end_if;	
	      options[i]:=FAIL;
	      break

	  of hold(DrawMode) do
	      v:=op(p,2);
	      if(v <> Vertical and v <> Horizontal) then
		error("option 'DrawMode': Vertical or Horizontal expected")
	      end_if;			   
	      options[i]:=FAIL;
	      break
    	  otherwise v:=op(p,1); error("Option '".expr2text(v)."' not known");
          end_case;
        end_if;	
       end_for;
      options:= subs( options,FAIL=null() ); // Liste kommt sonst durcheinander, da null() sofort cancelt.
    
  return (TRUE);
 end_proc:

// ------------------------------End Check-----------------------------
// ======================================================================


if args(0) < 1 then
        error("1st argument: expecting data")
end_if;

      // set_defaults
      color := RGB::ColorList; // default color list
      lineWidth:=12;
      useBounds:=Left;
      l2:=[];
      interv:=-1;
      width:=1;
      draw3D:=FALSE;

      notchIndent:=0;
      plotAgainst:=FALSE;
      centers:=[];
      widths:=[];
      stretch:=0;
      shift:=0;


      t := []; // Titles
      v := Vertical; // DrawMode=Vertical
      st := Box; // Style
      options := [args(2..args(0))]; // Array with Options listed in

      check(); // Check all Elements

      if (interv > 0) then //jetzt l2 selbst generieren
        useBounds:=Left;
      	// min und max der list l bestimmen
        if (not draw3D) then
                maxL:= max(op(l[1]));
                minL:= min(op(l[1]));
        else  //Jetzt ber ALLE Listen addieren
                maxL:= max(op(l[i])$i=1..nops(l));
                minL:= min(op(l[i])$i=1..nops(l));
        end_if;
        quot:=(maxL-minL)/interv;
        l2:=[];
        l2:=[ [minL+i*quot,minL+(i+1)*quot] $ i=0..interv-1];
        l2[nops(l2)][2]:=l2[nops(l2)][2]+1; // damit ALLE Werte erfasst werden mit UseBounds=Left.
      end_if;
    
    if testargs()
    // Check if the Types corresponds to our specification
    then 
    
    //Teste Liste 2
           small:=-infinity;
                  for j from 1 to nops(l2) do
                   	if  (op(l2,[j,1])>=op(l2,[j,2])) or (op(l2,[j,1])<=small) then //Error
                        if ((useBounds=Both) or (op(l2,[j,1])<>small)) and (small <> -infinity)then //Ausnahme
                           error("Second List of Lists must be in ascending order");
                       end_if;
                   	end_if;
                    small:=op(l2,[j,2]);
                  end_for;
    

    if not testtype(l, Type::ListOf(DOM_LIST)) 
            and not domtype(l) = DOM_ARRAY
            and not domtype(l) = stats::sample
            and not domtype(l) = DOM_LIST 
            and not l::dom::hasProp(Cat::Matrix) = TRUE
             then error("1st argument: list or list of lists or array or matrix or stat::sample expected")
         end_if;
         elif domtype(l) = DOM_ARRAY then 
            if op(l,[0,1]) <> 1  and op(l,[0,1]) <> 2
    	      then error("1st argument: array must be one or two-dimensional")
            end_if;
  
  
  end_if;

     //--------------------------------------------
     // Matrix, Array --> List of Lists :
     if l::dom::hasProp( Cat::Matrix ) = TRUE then
        l:= expr(l): // Matrix -> Array
     end_if;
     nli := [];
     if domtype(l) = DOM_ARRAY // then Array -> List of Lists
     then dim := op(l,[0,1]): // Dimension of Array
          
     	  startY:=op(l,[0,2,1]); //1. Y- Index im Array
	      startX:=op(l,[0,3,1]); //1. X-Index im Array
     	  rangeY:=op(l, [0,2,2])- startY; //Range in Y-Dimension
     	  rangeX:=op(l, [0,3,2])- startX; //Range in X-Dimension
	  
	  // Dieses seltsam anmutende Konstrukt ist notwendig, um auf die langsame Append-Funktion
	  // nicht zugreifen zu mssen.
          // i=Zeile, j=Spalte
	  if   dim = 2 then
                l:=[ [l[j,i] $ j=op(l, [0,2,1])..op(l, [0,2,2])] $ i= op(l, [0,3,1])..op(l, [0,3,2])  ]
	  elif dim = 1 then 
                l:= [ [l[i]   $ i= op(l,[0,2,1])..(op(l, [0,2,2]))]] // 1-dimensionaler Array in eine ListOfList
          end_if;
    end_if;
    if domtype(l)=stats::sample then l:=expr(l); end_if;
    if domtype(l[1])<>DOM_LIST then l:=[l] end_if;
    //---------------------------------------------
    // ---> Out: List of Lists --------

   	l := float(l);
        if (_union (map ( {op(l[i])},domtype )$i=1..nops(l)) minus {DOM_FLOAT}) <> {} then 
                error("Some data elements are not numerical"); 
        end_if;  
	boxList:=[];   
	
// -----------------------------------------------------------------
// ----START mit LISTENBEARBEITUNG----------------------------------
//------------------------------------------------------------------

for listnr from 1 to nops(l) do
    ranges:=[0$j=1..nops(l2)];

    for zaehl from 1 to nops(l[listnr]) do

            ranges:=sortIn(op(l,[listnr,zaehl]),1,nops(l2),l2,ranges); 
            //-> in ranges stehen die Anzahl der Elemente zw. den Intervallen drin
    end_for;
      print(ranges);      
    avgRange:=0;

   if (listnr=1) then

        l2Draw:=l2;
        // Suche Infintitys heraus und setze durch "vernnftige" Werte
          if (op(l2Draw,[1,1]))=-infinity or (op(l2Draw,[nops(l2Draw),2]))=infinity then
                for j from 2 to nops(l2Draw)-1 do
                    avgRange:=avgRange+op(l2Draw,[j,2])-op(l2Draw,[j,1])
                end_for;
             if ((op(l2Draw,[1,1]))=-infinity) then   
                if ((op(l2Draw,[nops(l2Draw),2]))=infinity) then
                
                    if (nops(l2Draw)=1) then //[-infty,+infty]von-1 bis 1
                        l2Draw[1][1]:=-1;
                        l2Draw[1][2]:=+1;
                    end_if;
                    if (nops(l2Draw)=2) then //[-infty,a][b,+infty]
                        l2Draw[1][1]:=(l2Draw[1][2]+l2Draw[2][1])/2;
                        l2Draw[2][2]:=(l2Draw[1][2]+3*l2Draw[2][1])/2;
                    end_if;
                    if (nops(l2Draw)>2) then
                        avgRange:=float(avgRange/(nops(l2Draw)-2));
                        l2Draw[1][1]:=l2Draw[1][2]-avgRange;
                        l2Draw[nops(l2Draw)][2]:=l2Draw[nops(l2Draw)][1]+avgRange;
                    end_if;
                 
                 else //rechts kein infinity
                    
                    if (nops(l2Draw)=1) then //[-infty,a]von a-1 bis 1
                        l2Draw[1][1]:=l2Draw[1][2]-1;
                    end_if;
                    if (nops(l2Draw)=2) then //[-infty,a][b1,b2]: a-(b2-b1)
                        l2Draw[1][1]:=l2Draw[1][2]-l2Draw[2][1]+l2Draw[2][2];
                    end_if;
                    if (nops(l2Draw)>2) then
                        avgRange:=avgRange+l2Draw[nops(l2Draw)][2]-l2Draw[nops(l2Draw)][1];
                        avgRange:=float(avgRange/(nops(l2Draw)-1));
                        l2Draw[1][1]:=l2Draw[1][2]-avgRange;
                    end_if;
                 end_if;

    else //(nur rechts infinity)
         	if (nops(l2Draw)=1) then //[a,infty] von a bis a+1
        		l2Draw[1][2]:=l2Draw[1][1]+1;
        	end_if;
        	if (nops(l2Draw)=2) then //[a1,a2][b1,infty]: b1+(a2-a1)
        		l2Draw[2][2]:=l2Draw[2][1]+l2Draw[1][2]-l2Draw[1][1];
        	end_if;
            if (nops(l2Draw)>2) then
                avgRange:=avgRange+l2Draw[1][2]-l2Draw[1][1];
     	        avgRange:=float(avgRange/(nops(l2Draw)-1));
                l2Draw[nops(l2Draw)][2]:=l2Draw[nops(l2Draw)][1]+avgRange;
            end_if;
      end_if;
    end_if;
  end_if;
		for zaehl from 1 to nops(l2Draw) do
	      
          if (draw3D=TRUE) then
          	    boxList:=append(boxList, 
                            //Rectangle
                        Box3d(
                            op(l2Draw,[zaehl,1]), //X-Wert
                            0,                //Y-Wert
                            listnr*width+(listnr-1)-width, //Z-Wert
                            op(l2Draw,[zaehl,2]),
                            ranges[zaehl],
                            listnr*width+(listnr-1)
                            )
                );
          else
              if (v=Horizontal) then
                boxList:=append(boxList, 
                            //Rectangle
                        plot::Rectangle2d(
                            myPoint(v,op(l2Draw,[zaehl,1]),0),   
                            ranges[zaehl],
                            op(l2Draw,[zaehl,2])-op(l2Draw,[zaehl,1]),
                            // Falls weniger Farben als Boxen starte von vorne.
                            hold(Color)=color[(zaehl-1 mod nops(color) )+1],
                            LineWidth=lineWidth,
                            Filled=TRUE
                         )
                );
              else
                  boxList:=append(boxList, 
                            //Rectangle
                            plot::Rectangle2d(
                            myPoint(v,op(l2Draw,[zaehl,1]),0),   
                            op(l2Draw,[zaehl,2])-op(l2Draw,[zaehl,1]),
                            ranges[zaehl],
                            // Falls weniger Farben als Boxen starte von vorne.
                            hold(Color)=color[(zaehl-1 mod nops(color) )+1],
                            LineWidth=lineWidth,
                            Filled=TRUE
                         )
                );
               end_if;
            end_if;
	    end_for;
       if (draw3D=FALSE) then
       	   return ( plot::Group(op(boxList))):	
       end_if;
end_for;
   return ( plot::Group(op(boxList))):	
 end_proc: /*of main*/
