
plotlib::testfloat := proc( 
                    fx,   /* DOM_PROC   */
                    fy,   /* DOM_PROC   */ 
		    a,    /* Type::Real */
		    b,    /* Type::Real */
		    l,    /* DOM_LIST   */
		    steps /* DOM_INT    */ 
		    )
   local ivc, ivx, ivy, mess, xmin, xmax, ymin, ymax;
begin
   a := float(a); b := float(b);
   [ivx, ivc, xmin, xmax] := numeric::testfloat(fx, a, b, steps);
   if ivx = [] then
      // fx(t) liefert im Interval [a, b] nur nicht reelle Werte
      if l <> [] then
         mess := expr2text(l[2][1]) . " returns no real numbers in\n";
         mess := mess . expr2text([a, b]);
         userinfo(1, mess);
      end_if;
      return( [ [], xmin, xmax, ymin, ymax ] );
   end_if;
   [ivy, ivc, ymin, ymax] := numeric::testfloat(fy, a, b, steps);
   if ivy = [] then
      // fy(t) liefert im Interval [a, b] nur nicht reelle Werte
      if l <> [] then
         mess := expr2text(l[2][2]) . " returns no real numbers in\n";
         mess := mess . expr2text([a, b]);
         userinfo(1, mess);
      end_if;
      return( [ [], xmin, xmax, ymin, ymax ] );
   else
      return( [ plotlib::combine_intervals(ivx, ivy, a, b, l),
                xmin, xmax, ymin, ymax ] );
   end_if;
end_proc:
