// $Date: 2002/02/20 12:39:06 $ $Author: bij $ $Revision: 1.8 $

//
// This file contains informations about changes
// between MuPAD 1.4.2 - 2.0, 2.0 - 2.5
//
// renamed objects
// 

///////////////////////////////////////////////////////////////////////////////////////////////////
//// Changes 2.0 -> 2.5 ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

slot(prog::Changes, "renamed2.5"):=
table(
      [hold(stats), hold(BPcorr)]                         = [hold(stats), hold(correlation)],
      [hold(stats), hold(FCorr)]                          = [hold(stats), hold(correlation)],
      [hold(stats), hold(a_quantil)]                      = [hold(stats), hold(empiricalQuantile)],
      [hold(stats), hold(geometric)]                      = [hold(stats), hold(geometricMean)],
      [hold(stats), hold(harmonic)]                       = [hold(stats), hold(harmonicMean)],
      [hold(stats), hold(normal)]                         = [hold(stats), hold(normalCDF)],
      [hold(stats), hold(quadratic)]                      = [hold(stats), hold(quadraticMean)],
      [hold(stats), hold(Tdist)]                          = [hold(stats), hold(tCDF)],
      [hold(stats), hold(meanTest)]                       = [hold(stats), hold(tTest)],
      [hold(numeric), hold(lagrange)]                     = [hold(System), hold(interpolate)]
      ):

slot(prog::Changes, "renamedLibs2.5"):=
table():

slot(prog::Changes, "renamedSlots2.0"):=
table():


///////////////////////////////////////////////////////////////////////////////////////////////////
//// Changes 1.4.2 -> 2.0  ////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

slot(prog::Changes, "renamed2.0"):=
table(
      [hold(Cat), hold(DifferentialVariableCat)]           = [hold(Cat), hold(DifferentialVariable)],
      [hold(Cat), hold(FiniteCollectionCat)]               = [hold(Cat), hold(FiniteCollection)],
      [hold(Cat), hold(HomogeneousFiniteCollectionCat)]    = [hold(Cat), hold(HomogeneousFiniteCollection)],
      [hold(Cat), hold(HomogeneousFiniteProductCat)]       = [hold(Cat), hold(HomogeneousFiniteProduct)],
      [hold(Cat), hold(MatrixCat)]                         = [hold(Cat), hold(Matrix)],
      [hold(Cat), hold(PolynomialCat)]                     = [hold(Cat), hold(Polynomial)],
      [hold(Cat), hold(RestrictedDifferentialFunctionCat)] = [hold(Cat), hold(RestrictedDifferentialFunction)],
      [hold(Cat), hold(SetCat)]                            = [hold(Cat), hold(BaseCategory)],
      [hold(Cat), hold(SquareMatrixCat)]                   = [hold(Cat), hold(SquareMatrix)],
      [hold(Cat), hold(UnivariatePolynomialCat)]           = [hold(Cat), hold(UnivariatePolynomial)],
      [hold(Cat), hold(UnivariateSkewPolynomialCat)]       = [hold(Cat), hold(UnivariateSkewPolynomial)],
      [hold(Dom), hold(Pade)]                              = [hold(System), hold(pade)],
      [hold(Network), hold(AddEdge)]                       = [hold(Network), hold(addEdge)],
      [hold(Network), hold(AddVertex)]                     = [hold(Network), hold(addVertex)],
      [hold(Network), hold(AdmissibleFlow)]                = [hold(Network), hold(admissibleFlow)], 
      [hold(Network), hold(AllShortPath)]                  = [hold(Network), hold(allShortPath)],
      [hold(Network), hold(Blockflow)]                     = [hold(Network), hold(blockflow)],
      [hold(Network), hold(ChangeEdge)]                    = [hold(Network), hold(changeEdge)],
      [hold(Network), hold(ChangeVertex)]                  = [hold(Network), hold(changeVertex)],
      [hold(Network), hold(Complete)]                      = [hold(Network), hold(complete)],
      [hold(Network), hold(ConvertSSQ)]                    = [hold(Network), hold(convertSSQ)],
      [hold(Network), hold(Cycle)]                         = [hold(Network), hold(cycle)],
      [hold(Network), hold(DelEdge)]                       = [hold(Network), hold(delEdge)],
      [hold(Network), hold(DelVertex)]                     = [hold(Network), hold(delVertex)],
      [hold(Network), hold(ECapacity)]                     = [hold(Network), hold(eCapacity)],
      [hold(Network), hold(EWeight)]                       = [hold(Network), hold(eWeight)],
      [hold(Network), hold(Edge)]                          = [hold(Network), hold(edge)],
      [hold(Network), hold(Epost)]                         = [hold(Network), hold(epost)],
      [hold(Network), hold(Epre)]                          = [hold(Network), hold(epre)],
      [hold(Network), hold(InDegree)]                      = [hold(Network), hold(inDegree)],
      [hold(Network), hold(IsEdge)]                        = [hold(Network), hold(isEdge)],
      [hold(Network), hold(IsVertex)]                      = [hold(Network), hold(isVertex)],
      [hold(Network), hold(LongPath)]                      = [hold(Network), hold(longPath)],
      [hold(Network), hold(MaxFlow)]                       = [hold(Network), hold(maxFlow)],
      [hold(Network), hold(MinCost)]                       = [hold(Network), hold(minCost)],
      [hold(Network), hold(MinCut)]                        = [hold(Network), hold(minCut)],
      [hold(Network), hold(OutDegree)]                     = [hold(Network), hold(outDegree)],
      [hold(Network), hold(PrintGraph)]                    = [hold(Network), hold(printGraph)],
      [hold(Network), hold(Random)]                        = [hold(Network), hold(random)],
      [hold(Network), hold(ResidualNetwork)]               = [hold(Network), hold(residualNetwork)],
      [hold(Network), hold(ShortPath)]                     = [hold(Network), hold(shortPath)],
      [hold(Network), hold(ShortPathTo)]                   = [hold(Network), hold(shortPathTo)],
      [hold(Network), hold(ShowGraph)]                     = [hold(Network), hold(showGraph)],
      [hold(Network), hold(TopSort)]                       = [hold(Network), hold(topSort)],
      [hold(Network), hold(VWeight)]                       = [hold(Network), hold(vWeight)],
      [hold(Network), hold(Vertex)]                        = [hold(Network), hold(vertex)],
      [hold(System), hold(CF)]                             = [hold(numlib),hold(contfrac)],
      [hold(System), hold(Lsys)]                           = [hold(plotlib), hold(Lsys)],
      [hold(System), hold(Lsys)]                           = [hold(plotlib), hold(Lsys)],
      [hold(System), hold(NUMERIC)]                        = [hold(Type), hold(Numeric)],
      [hold(System), hold(Poly)]                           = [hold(polylib), hold(Poly)],
      [hold(System), hold(Puiseux)]                        = [hold(Series),hold(Puiseux)],
      [hold(System), hold(acos)]                           = [hold(System), hold(arccos)],
      [hold(System), hold(acosh)]                          = [hold(System), hold(arccosh)],
      [hold(System), hold(acot)]                           = [hold(System), hold(arccot)],
      [hold(System), hold(acoth)]                          = [hold(System), hold(arccoth)],
      [hold(System), hold(acsc)]                           = [hold(System), hold(arccsc)],
      [hold(System), hold(acsch)]                          = [hold(System), hold(arccsch)],
      [hold(System), hold(algsolve)]                       = [hold(solvelib), hold(algebraic)],
      [hold(System), hold(algsolve)]                       = [hold(solvelib), hold(algebraic)],
      [hold(System), hold(asec)]                           = [hold(System), hold(arcsec)],
      [hold(System), hold(asech)]                          = [hold(System), hold(arcsech)],
      [hold(System), hold(asin)]                           = [hold(System), hold(arcsin)],
      [hold(System), hold(asinh)]                          = [hold(System), hold(arcsinh)],
      [hold(System), hold(assign_elems)]                   = [hold(System), hold(assignElements)],
      [hold(System), hold(atan)]                           = [hold(System), hold(arctan)],
      [hold(System), hold(atanh)]                          = [hold(System), hold(arctanh)],
      [hold(System), hold(breakmap)]                       = [hold(misc), hold(breakmap)],
      [hold(System), hold(built_in)]                       = [hold(System), hold(builtin)],
      [hold(System), hold(catalan)]                        = [hold(Sysvar),hold(CATALAN)],
      [hold(System), hold(changevar)]                      = [hold(intlib), hold(changevar)],
      [hold(System), hold(changevar)]                      = [hold(intlib), hold(changevar)],
      [hold(System), hold(contfrac)]                       = [hold(numlib), hold(contfrac)],
      [hold(System), hold(contfrac)]                       = [hold(numlib), hold(contfrac)],
      [hold(System), hold(decompose)]                      = [hold(polylib), hold(decompose)],
      [hold(System), hold(decompose)]                      = [hold(polylib), hold(decompose)],
      [hold(System), hold(discrim)]                        = [hold(polylib), hold(discrim)],
      [hold(System), hold(discrim)]                        = [hold(polylib), hold(discrim)],
      [hold(System), hold(domainfunccall)]                 = [hold(System), hold(_domainfunccall)],
      [hold(System), hold(domattr)]                        = [hold(System), hold(slot)],
      [hold(System), hold(domattr)]                        = [hold(System), hold(slot)],
      [hold(System), hold(eint)]                           = [hold(System), hold(Ei)],
      [hold(System), hold(fft)]                            = [hold(numeric), hold(fft)],
      [hold(System), hold(fft)]                            = [hold(numeric), hold(fft)],
      [hold(System), hold(func_env)]                       = [hold(System), hold(funcenv)],
      [hold(System), hold(funcattr)]                       = [hold(System), hold(slot)],
      [hold(System), hold(funcattr)]                       = [hold(System), hold(slot)],
      [hold(System), hold(gseries)]                        = [hold(Series),hold(gseries)],
      [hold(System), hold(ifft)]                           = [hold(numeric), hold(invfft)],
      [hold(System), hold(ifft)]                           = [hold(numeric), hold(invfft)],
      [hold(System), hold(index_val)]                      = [hold(System), hold(indexval)],
      [hold(System), hold(insert_ordered)]                 = [hold(listlib), hold(insert)],
      [hold(System), hold(lagrange)]                       = [hold(numeric), hold(lagrange)],
// fuer MuPAD 2.0 -> 2.1: numeric::lagrange --> (stdlib) interpolate
//    [hold(numeric),hold(lagrange)]                       = [hold(System), hold(interpolate)],
      [hold(System), hold(lazy_and)]                       = [hold(System), hold(_lazy_and)],
      [hold(System), hold(linsert)]                        = [hold(listlib), hold(insertAt)],
      [hold(System), hold(load)]                           = [hold(module), hold(load)],
      [hold(System), hold(load)]                           = [hold(module), hold(load)],
      [hold(System), hold(maprec)]                         = [hold(misc), hold(maprec)],
      [hold(System), hold(new_bytecode)]                   = [hold(System), hold(_new_bytecode)],
      [hold(System), hold(op_fconcat)]                     = [hold(System), hold(_op_fconcat)],
      [hold(System), hold(op_plusmult)]                    = [hold(System), hold(_op_plusmult)],
      [hold(System), hold(op_power)]                       = [hold(System), hold(_op_power)],
      [hold(System), hold(optimize)]                       = [hold(generate), hold(optimize)],
      [hold(System), hold(pdioe)]                          = [hold(solvelib), hold(pdioe)],
      [hold(System), hold(phi)]                            = [hold(numlib),hold(phi)],
      [hold(System), hold(plotfunc)]                       = [hold(System),hold(plotfunc2d),hold(plotfunc3d)],
      [hold(System), hold(primpart)]                       = [hold(polylib), hold(primpart)],
      [hold(System), hold(profile)]                        = [hold(prog), hold(profile)],
      [hold(System), hold(randpoly)]                       = [hold(polylib), hold(randpoly)],
      [hold(System), hold(repcom)]                         = [hold(System), hold(_fnest)],
      [hold(System), hold(resultant)]                      = [hold(polylib), hold(resultant)],
      [hold(System), hold(spline)]                         = [hold(numeric), hold(cubicSpline)],
      [hold(System), hold(sqrfree)]                        = [hold(polylib), hold(sqrfree)],
      [hold(System), hold(strlen)]                         = [hold(System), hold(length)],
      [hold(System), hold(strlen)]                         = [hold(System), hold(length)],
      [hold(System), hold(sysunassign)]                    = [hold(System), hold(sysdelete)],
      [hold(System), hold(unassign)]                       = [hold(System), hold(_delete)],
      [hold(Sysvar), hold(LIB_PATH)]                       = [hold(Sysvar), hold(LIBPATH)],
      [hold(Sysvar), hold(PRETTY_PRINT)]                   = [hold(Sysvar), hold(PRETTYPRINT)],
      [hold(Sysvar), hold(READ_PATH)]                      = [hold(Sysvar), hold(READPATH)],
      [hold(Sysvar), hold(TEST_PATH)]                      = [hold(Sysvar), hold(TESTPATH)],
      [hold(Sysvar), hold(WRITE_PATH)]                     = [hold(Sysvar), hold(WRITEPATH)],
      [hold(Type), hold(RealNum)]                          = [hold(Type), hold(Real)],
      [hold(contrib), hold(pslq)]                          = [hold(misc), hold(pslq)],
      [hold(linalg), hold(cholesky)]                       = [hold(linalg), hold(factorCholesky)],
      [hold(linalg), hold(dimen)]                          = [hold(linalg), hold(matdim)],
      [hold(linalg), hold(eigenValues)]                    = [hold(linalg), hold(eigenvalues)],
      [hold(linalg), hold(eigenVectors)]                   = [hold(linalg), hold(eigenvectors)],
      [hold(linalg), hold(extractMatrix)]                  = [hold(linalg), hold(submatrix)],
      [hold(linalg), hold(isHermitian)]                    = [hold(linalg), hold(isHermitean)],
      [hold(linalg), hold(linearSolve)]                    = [hold(linalg), hold(matlinsolve)],
      [hold(linalg), hold(linearSolveLU)]                  = [hold(linalg), hold(matlinsolveLU)],
      [hold(linalg), hold(ogSystem)]                       = [hold(linalg), hold(orthog)],
      [hold(linalg), hold(vectorDimen)]                    = [hold(linalg), hold(vecdim)],
      [hold(misc), hold(check)]                            = [hold(prog), hold(check)],
      [hold(misc), hold(checkExample)]                     = [hold(prog), hold(checkExample)],
      [hold(misc), hold(freeze)]                           = [hold(System), hold(freeze)],
      [hold(misc), hold(makelib)]                          = [hold(prog), hold(makebinlib)],
      [hold(misc), hold(tableForm)]                        = [hold(output), hold(tableForm)],
      [hold(misc), hold(tcov)]                             = [hold(prog), hold(tcov)],
      [hold(misc), hold(test)]                             = [hold(prog), hold(test)],
      [hold(numeric), hold(bairstow)]                      = [hold(numeric), hold(polyroots)],
      [hold(numeric), hold(bisect)]                        = [hold(numeric), hold(realroot)],
      [hold(numeric), hold(fint)]                          = [hold(numeric), hold(int)],
      [hold(numeric), hold(newton)]                        = [hold(numeric), hold(fsolve)],
      [hold(numeric), hold(vonMieses)]                     = [hold(numeric), hold(spectralradius)],
      [hold(property), hold(isprop)]                       = [hold(property), hold(implies)],
      [hold(sharelib), hold(Lsys)]                         = [hold(plotlib), hold(Lsys)],
      [hold(sharelib), hold(animate)]                      = [hold(plotlib), hold(animate)],
      [hold(sharelib), hold(iroots)]                       = [hold(solvelib), hold(iroots)],
      [hold(sharelib), hold(plotsetup)]                    = [hold(plotlib), hold(plotsetup)],
      [hold(sharelib), hold(rational)]                     = [hold(numeric), hold(rationalize)],
      [hold(sharelib), hold(trace)]                        = [hold(prog), hold(trace)],
      [hold(sharelib), hold(turtle)]                       = [hold(plotlib), hold(Turtle)],
      [hold(sharelib), hold(untrace)]                      = [hold(prog), hold(untrace)],
      [hold(string), "delete"]                             = [hold(stringlib), hold(remove)],
      [hold(transform), hold(ifourier)]                    = [hold(transform), hold(invfourier)],
      [hold(transform), hold(ilaplace)]                    = [hold(transform), hold(invlaplace)]
      ):

slot(prog::Changes, "renamedLibs2.0"):=
table(
      // renamed libraries
      [hold(string)]                                       = [hold(stringlib)],
      [hold(listtools)]                                    = [hold(listlib)],
      [hold(io)]                                           = [hold(import)]
      ):

slot(prog::Changes, "renamedSlots2.0"):=
table(
      [hold(Dom), hold(Matrix)]                            = ["dimen" = "matdim", "newThis" = "create"]
      ):

