DOM_COMPLEX::NRange:=
	proc(co)
	begin
	  if iszero(op(co, 1)) then
	    if domtype(op(co, 2)) = DOM_INT then
	      return(property::NRange("IntImaginary", "Real"))
	    else
	      return(property::NRange("Imaginary", "Real"))
	    end_if
	  else
	    return(property::NRange("Complex", "Real"))
	  end_if
	end_proc:

// only for compatibility
DOM_COMPLEX::Residue:=
  proc(co, OPT = hold(Exact))
  begin
    //if OPT = hold(Exact) then
      FAIL
    //else
    //  DOM_COMPLEX::NRange(co)
    //end_if
  end_proc:

DOM_COMPLEX::Complex:=
  proc(co)
  begin
    property::Complex(map(op(co), X -> if contains(X::dom, "Residue") then
                                         X::dom::Residue(X)
                                       else
                                         X::dom::Rel(X)
                                       end_if))
  end_proc:

DOM_COMPLEX::Rel:=
  proc(co)
  begin
    property::Rel(_equal, co)
  end_proc: