DOM_EXPR::NRange:=
	proc(ex, OPT = hold(Exact))
        begin
          if testtype(ex, Type::Real) then
            if OPT = hold(Exact) then
              FAIL
            else
              if float(ex) <> ex then
                DOM_FLOAT::NRange(float(ex))
              else
                FAIL
              end_if
            end_if
          else
            FAIL
          end_if
	end_proc:

DOM_EXPR::Complex:= DOM_EXPR::NRange:

DOM_EXPR::IV:=
	proc(ex)
	begin
          if testtype(ex, Type::Real) then
            property::IV([ex, ex], ex::dom::NRange(ex))
          else
            FAIL
          end_if
        end_proc:

DOM_EXPR::Rel:=
	proc(ex, OPT = hold(Exact))
        begin
          if testtype(ex, Type::Arithmetical) then
            if OPT = hold(Exact) then
              return(property::Rel(hold(_equal), ex))
            else
              return(property::Rel(hold(_equal), float(ex)))
            end_if
          else
            FAIL
          end_if
	end_proc:
