// $Date: 2002/02/12 14:05:24 $ $Author: stefanw $ $Revision: 1.3 $

// neues simplify
//
// bij 2000/2001

Simplify:= newDomain("Simplify"):
Simplify::create_dom:=hold(Simplify):

Simplify::new:=
  proc(X, OPT = hold(None))
    local argv;
  begin
    argv:= [args(2..args(0))];
    if contains(argv, hold(All)) = 0  then
      op(Simplify::simplify(args()), [1, 1])
    else
      argv:= select(argv, _unequal, hold(All));
      Simplify::simplify(X, op(argv))
    end_if
  end_proc:

alias(path = pathname("SIMPLIFY")):

Simplify::simplify:= loadproc(Simplify::simplify, path, "Simpsimp"):
Simplify::complexity:= loadproc(Simplify::complexity, path, "complxty"):
Simplify::operatorComplexity:= loadproc(Simplify::operatorComplexity, path,
                                        "complxty"): 
Simplify::depth   := loadproc(Simplify::depth, path, "complxty"):

// Simplify::simplifyConditions:= loadproc(Simplify::simplifyConditions, path, "simpexpr"):

null():
