// $Date: 2001/11/12 17:55:45 $ $Author: stefanw $ $Revision: 1.1 $

// 
// patt, repl, OPT (wie fur match)
// 
// 
// 
// 
// 

Rule::_and:=
  [
   // expand (distributive law)
   Rule(A and (B or C), hold(A and B or A and C)),
   
   Rule(not A and not B, hold(not (A or B))),
   Rule(A and x < y, hold(A and bool(x < y)),
        Cond = {x -> testtype(x, Type::Constant),
                y -> testtype(y, Type::Constant)}),

   // substitutivity of =

   Rule(A=B and C, hold(A=B and subs(C, A=B))),

   // set operations
   Rule(a in B and a in C, hold(a in B intersect C)),
   Rule(a in B and not a in C, hold(a in B minus C))
   

   ]:
