// $Date: 2001/11/12 17:55:45 $ $Author: stefanw $ $Revision: 1.1 $

// 
// patt, repl, OPT (wie fur match)
// 
// 
// 
// 
// 

Rule::_in:=
  [
   Rule(a in {}, FALSE),
   Rule(a in {x}, a=x),
   // solange Bezeichner komplexe Zahlen repr.
   Rule(a in C_, TRUE),

   Rule(a in R_, TRUE, {X -> is(X, Type::Real)}),

   
   Rule(a in B union C, hold(a in B or a in C)),
   Rule(a in B intersect C, hold(a in B and a in C)),

   // spezielle Mengen auf rechter Seite
   Rule(X, expand(X), {X -> type(op(X,2))=Dom::Interval}),



   // Rules that state that certain sets are closed under certain
   // operations

   Rule(a*b in R_, a in  R_, {b -> is(b, Type::Real)=TRUE and is(b<>0)=TRUE}),
   Rule(a+b in R_, a in R_, {b -> is(b, Type::Real) = TRUE}),
   Rule(a^2 in R_, hold(a in R_ or a/I in R_)),
   Rule(a^b in R_, a in R_, {b -> type(b)=DOM_RAT})
   
]:
   
