// $Date: 2001/11/12 17:55:45 $ $Author: stefanw $ $Revision: 1.1 $

// 
// patt, repl, OPT (wie fur match)
// 
// 
// 
// 
// 

Rule::_or:=
  [

   // distributive law

   Rule(A or B and C, hold((A or B) and (A or C))),
   
   // de-expand
   Rule(A and B or A and C, hold(A and (B or C))),
   
   Rule(not A or not B, hold(not (A and B))),

   // aus simplify::logic
   Rule(A or A and B, A),
   Rule(b and c or not c, hold(b or not c)),
   Rule(not a and c or b and not c or not b and not c, hold(not a or not c)),
   Rule((a and b) or (a and (not b)), a),
   Rule((a and b) or (not a and c) or (b and c), hold(a and b or not a and c)),
   Rule(A or x < y, hold(A or bool(x < y)), Cond = {x -> testtype(x, Type::Constant),
                                                    y -> testtype(y, Type::Constant)}),


   // _or von Ausdruecken mit _in
   Rule(a in B or a in C, hold(a in B union C))
   
   ]:
