
//
//   bij - 1998/99
//   
//   Pattern matching
//
//

matchlib:=newDomain("matchlib"):
matchlib::create_dom:=hold(matchlib):
matchlib::info:= "Library 'matchlib': tools for pattern matching":

matchlib::interface:=
  {hold(match),
   hold(analyze)}:

matchlib::exported:=
  {hold(match)}:

alias(path = pathname("MATCHLIB")):
// the same as STDLIB: match
matchlib::match:=     loadproc(matchlib::match,     path, "match"):
matchlib::ismatch:=   loadproc(matchlib::ismatch,   path, "ismatch" ):
matchlib::matchgen:=  loadproc(matchlib::matchgen,  path, "matchgen"):
matchlib::analyze:=   loadproc(matchlib::analyze,   path, "analyze" ):
//matchlib::matchtree:= loadproc(matchlib::matchtree, path, "matchtre"):

stdlib::LoadlibState["matchlib"]:= TRUE:

null():
