

// find operands
prog::find:=
  proc(ARG, SOBJ, RESULT = [])
    local i;
  begin
    if testargs() then
      if args(0) < 2 then
        error("wrong number of arguments")
      end_if
    end_if;
    
    if ARG = SOBJ then
      return(RESULT)
    end_if;
    
    case domtype(ARG)
      of DOM_EXPR do
      of DOM_LIST do
      of DOM_TABLE do
      of DOM_INTERVAL do
      of DOM_RAT do
      of DOM_SET do
        RESULT:= [prog::find(op(ARG, i), SOBJ, append(RESULT, i)) $ i = 0..nops(ARG)];
        break
      of DOM_PROC do
        RESULT:= [prog::find(op(ARG, [4, i]), SOBJ, append(RESULT, 4, i)) $ i = 1..nops(op(ARG, 4))];
        break
      of DOM_COMPLEX do
        // special: 'I'
      otherwise
        RESULT:= []
    end_case;

    op(RESULT)
  end_proc: