DOM_INT::NRange:=
	proc(i, OPT = hold(Exact))
          local rg;
        begin
          if i = 0 then
	    return(property::NRange("Zero"))
	  else
	    if i > 0 then
	      rg:= property::NRange("PosInt", "Zero")
	    elif i < 0 then
	      rg:= property::NRange("NegInt", "Zero")
	    else
	      rg:= property::NRange("Integer", "Zero")
	    end_if
          end_if;
          if OPT <> hold(Exact) then
            rg
          else
            property::Residue(i, 0, rg)
            //DOM_INT::Rel(i)
          end_if
	end_proc:

DOM_INT::Complex:=
  proc(i)
    begin
      property::Complex(DOM_INT::Residue(i), Type::Zero)
  end_proc:

DOM_INT::Residue:=
	proc(i)
        begin
          property::Residue(i, 0, DOM_INT::NRange(i, hold(Sloppy)))
	end_proc:

DOM_INT::IV:=
	proc(i)
	begin
	  return(property::IV([i, i], i::dom::NRange(i, hold(Exact))))
	end_proc:

DOM_INT::Rel:=
	proc(i)
        begin
	  return(property::Rel(hold(_equal), i))
	end_proc:

