// $Date: 2001/12/03 09:49:03 $  $Author: walter $   $Revision: 1.12 $ 

/*--
usage:
median(l) / median(s, c)

median value, 0.5-quantile
--*/
/*--
parameters:
l  list or sequence
s  stats::sample
c  data-column index (optional if sample contains only one data-column)
--*/

stats::median := funcenv(proc()
begin
  if has([args()], Averaged) then
     stats::empiricalQuantile(subs(args(), Averaged = null()))(1/2, Averaged);
  else
     stats::empiricalQuantile(args())(1/2);
  end_if;
end_proc):
stats::median::Content := (Out, x) -> Out::Capply(Out::Cmedian, Out(op(x))):

// end of file 
 
