
/*
The Scilab data type Tlist
*/

scilab::Tlist:=newDomain("scilab::Tlist"):
scilab::Tlist::info:="scilab::Tlist - the domain of Scilab type tlist":
scilab::Tlist::new:=
proc(x: DOM_LIST)
begin
  if nops(x) = 0 then
    error("A Tlist can't be empty")
  end_if ;
  if domtype(op(x,1)) <> DOM_STRING then
    error("The first element of a Tlist must be a string.")
  end_if;
  new(scilab::Tlist, x)
end_proc:
scilab::Tlist::op:= x-> op(extop(x,1), args(2..args(0))):
scilab::Tlist::nops:= x -> nops(extop(x,1)):
scilab::Tlist::_index:= x -> _index(extop(x,1), args(2..args(0))):
scilab::Tlist::print:= x -> extop(x,1):
scilab::Tlist::expr:= x -> extop(x,1):
