
// $Id: trans-cf.h,v 1.2 2001/09/12 08:34:27 ccr Exp $

// transcendental functions implemented via continued fractions

#ifndef trans_cf_h_
#define trans_cf_h_

GEN igammacf(long prec, GEN a, GEN x);
GEN ibeta(long prec, GEN a, GEN b, GEN x);

// Utility class: Save Pari stack position, restore when
// instance goes out of scope
class saveAvma {
 private:
  long avmaold;
 public:
  saveAvma() : avmaold(avma) {}
  ~saveAvma() { 
    avma = avmaold;
  }
};

#endif
